-- 2017-12-12 13:16:16
-- Задача №0009358: ВУТ. Учет документов. Корректирующие скрипты. ДЛЯ ОДНОКРАТНОГО ПРИМЕНЕНИЯ!!!!
-- Создаём запись в таблице TempInvalidDocument, если её там нет, и заполняем поля из таблицы TempInvalid Серия, Номер, Занятость, Место работы, Пациент 1, Дата выдачи, master_id, createDatetime, modifyDatetime
DELIMITER $$

DROP PROCEDURE IF EXISTS updateTempInvalid$$

CREATE DEFINER=`root`@`localhost` PROCEDURE `updateTempInvalid`()
    MODIFIES SQL DATA
    COMMENT 'update for table TempInvalid and TempInvalidDocument'
BEGIN

    DECLARE vSerial VARCHAR(255);
    DECLARE vNumber VARCHAR(255);
    DECLARE vTempInvalidID INT;
    DECLARE vClientID INT;
    DECLARE vReceiverID INT;
    DECLARE vTempClientID INT;
    DECLARE vGrouping TINYINT(1);
    DECLARE vPlaceWork  VARCHAR(255);
    DECLARE vBusyness TINYINT(1);
    DECLARE vIssueDate DATE;
    DECLARE vDone    INT DEFAULT 0;
    DECLARE vReplaceCursor CURSOR FOR SELECT TempInvalid.id, TempInvalid.serial, TempInvalid.number, TempInvalid.busyness, TempInvalid.placeWork, TempInvalid.issueDate, TempInvalid.client_id, TempInvalid.receiver_id, rbTempInvalidReason.grouping
                                                                     FROM TempInvalid
                                                                     LEFT JOIN rbTempInvalidReason ON rbTempInvalidReason.id = TempInvalid.tempInvalidReason_id
                                                                     WHERE TempInvalid.deleted = 0 AND NOT EXISTS(SELECT TempInvalidDocument.id
                                                                                                                                                      FROM TempInvalidDocument
                                                                                                                                                      WHERE TempInvalidDocument.master_id = TempInvalid.id
                                                                                                                                                      AND TempInvalidDocument.deleted = 0)
                                                                     ORDER BY id ASC;
    DECLARE CONTINUE HANDLER FOR NOT FOUND SET vDone = 1;

    OPEN vReplaceCursor;
    REPEAT
        FETCH vReplaceCursor INTO vTempInvalidID, vSerial, vNumber, vBusyness, vPlaceWork, vIssueDate, vClientID, vReceiverID, vGrouping;
        IF NOT vDone THEN
            IF vTempInvalidID IS NOT NULL THEN
                SET vTempClientID = NULL;
                IF vGrouping = 1 THEN
                    SET vTempClientID = vClientID;
                END IF;
                INSERT INTO TempInvalidDocument (serial, number, busyness, placeWork, issueDate, master_id, clientPrimum_id, createDatetime, modifyDatetime) VALUES(vSerial, vNumber, vBusyness, vPlaceWork, vIssueDate, vTempInvalidID, vTempClientID, NOW(), NOW());
            END IF;
        END IF;
    UNTIL vDone
    END REPEAT;
    CLOSE vReplaceCursor;

END$$

-- Меняем TempInvalid.client_id на TempInvalid.receiver_id, если TempInvalid.receiver_id IS NOT NULL (иначе целостность базы данных не позволяет) и rbTempInvalidReason.grouping == 1 (уход).
DROP PROCEDURE IF EXISTS updateTempInvalidClientId$$

CREATE DEFINER=`root`@`localhost` PROCEDURE `updateTempInvalidClientId`()
    MODIFIES SQL DATA
    COMMENT 'update client_id for table TempInvalid'
BEGIN

    DECLARE vTempInvalidID INT;
    DECLARE vReceiverID INT;
    DECLARE vGrouping TINYINT(1);
    DECLARE vDone    INT DEFAULT 0;
    DECLARE vReplaceCursor CURSOR FOR SELECT TempInvalid.id, TempInvalid.receiver_id, rbTempInvalidReason.grouping
                                                                     FROM TempInvalid
                                                                     LEFT JOIN rbTempInvalidReason ON rbTempInvalidReason.id = TempInvalid.tempInvalidReason_id
                                                                     WHERE TempInvalid.deleted = 0 AND rbTempInvalidReason.grouping = 1
                                                                     ORDER BY id ASC;
    DECLARE CONTINUE HANDLER FOR NOT FOUND SET vDone = 1;

    OPEN vReplaceCursor;
    REPEAT
        FETCH vReplaceCursor INTO vTempInvalidID, vReceiverID, vGrouping;
        IF NOT vDone THEN
            IF vTempInvalidID IS NOT NULL THEN
                IF vGrouping = 1 AND vReceiverID IS NOT NULL THEN
                    UPDATE TempInvalid SET client_id = vReceiverID WHERE id = vTempInvalidID;
                END IF;
            END IF;
        END IF;
    UNTIL vDone
    END REPEAT;
    CLOSE vReplaceCursor;

END$$

-- Заполняем новые  поля таблицы TempInvalid из таблицы TempInvalid_Period.
DROP PROCEDURE IF EXISTS updateTempInvalidByPeriod$$

CREATE DEFINER=`root`@`localhost` PROCEDURE `updateTempInvalidByPeriod`()
    MODIFIES SQL DATA
    COMMENT 'update table TempInvalid by TempInvalid_Period'
BEGIN

    DECLARE vTempInvalidID INT;
    DECLARE vTempInvalidPeriodID INT;
    DECLARE vResultID INT;
    DECLARE vResultDate DATE;
    DECLARE vTempResultDate DATE;
    DECLARE vBreakID INT;
    DECLARE vDisabilityID INT;
    DECLARE vAble TINYINT(1);
    DECLARE vDone    INT DEFAULT 0;
    DECLARE vReplaceCursor CURSOR FOR SELECT TempInvalid_Period.id, TempInvalid_Period.master_id, TempInvalid_Period.break_id, TempInvalid_Period.result_id, TempInvalid_Period.endDate,
    TempInvalid_Period.disability_id, rbTempInvalidResult.able
                                                                     FROM TempInvalid_Period LEFT JOIN rbTempInvalidResult ON rbTempInvalidResult.id = TempInvalid_Period.result_id
                                                                     WHERE 1
                                                                     GROUP BY master_id
                                                                     ORDER BY endDate DESC;
    DECLARE CONTINUE HANDLER FOR NOT FOUND SET vDone = 1;

    OPEN vReplaceCursor;
    REPEAT
        FETCH vReplaceCursor INTO vTempInvalidPeriodID, vTempInvalidID, vBreakID, vResultID, vResultDate, vDisabilityID, vAble;
        IF NOT vDone THEN
            IF vTempInvalidID IS NOT NULL THEN
                SET vTempResultDate = vResultDate;
                UPDATE TempInvalid SET break_id = vBreakID, result_id = vResultID, resultDate = vTempResultDate, disability_id = vDisabilityID WHERE id = vTempInvalidID;
                IF vAble = 1 THEN
                    SET vTempResultDate = DATE_ADD(vResultDate, INTERVAL 1 DAY);
                    UPDATE TempInvalid SET resultDate = vTempResultDate WHERE id = vTempInvalidID;
                ELSE
                    UPDATE TempInvalid SET resultOtherwiseDate = vTempResultDate WHERE id = vTempInvalidID;
                END IF;
            END IF;
        END IF;
    UNTIL vDone
    END REPEAT;
    CLOSE vReplaceCursor;

END$$

-- Заполняем новые  поля таблицы TempInvalid из таблицы TempInvalid_Period для путёвки.
DROP PROCEDURE IF EXISTS updateTempInvalidByPeriodPermit$$

CREATE DEFINER=`root`@`localhost` PROCEDURE `updateTempInvalidByPeriodPermit`()
    MODIFIES SQL DATA
    COMMENT 'update table TempInvalid by TempInvalid_Period'
BEGIN

    DECLARE vNumberPermit VARCHAR(255);
    DECLARE vBegDatePermit DATE;
    DECLARE vEndDatePermit DATE;
    DECLARE vTempInvalidID INT;
    DECLARE vTempInvalidPeriodID INT;
    DECLARE vDone    INT DEFAULT 0;
    DECLARE vReplaceCursor CURSOR FOR SELECT TempInvalid_Period.id, TempInvalid_Period.master_id, TempInvalid_Period.numberPermit, TempInvalid_Period.begDatePermit, TempInvalid_Period.endDatePermit
                                                                     FROM TempInvalid_Period
                                                                     WHERE TRIM(TempInvalid_Period.numberPermit) != '' AND TempInvalid_Period.begDatePermit IS NOT NULL AND TempInvalid_Period.endDatePermit IS NOT NULL
                                                                     GROUP BY master_id
                                                                     ORDER BY endDate DESC;
    DECLARE CONTINUE HANDLER FOR NOT FOUND SET vDone = 1;

    OPEN vReplaceCursor;
    REPEAT
        FETCH vReplaceCursor INTO vTempInvalidPeriodID, vTempInvalidID, vNumberPermit, vBegDatePermit, vEndDatePermit;
        IF NOT vDone THEN
            IF vTempInvalidID IS NOT NULL THEN
                UPDATE TempInvalid SET numberPermit = vNumberPermit, begDatePermit = vBegDatePermit, endDatePermit = vEndDatePermit WHERE id = vTempInvalidID;
            END IF;
        END IF;
    UNTIL vDone
    END REPEAT;
    CLOSE vReplaceCursor;

END$$

-- Применение процедур.
CALL updateTempInvalid()$$
CALL updateTempInvalidClientId()$$
CALL updateTempInvalidByPeriod()$$
CALL updateTempInvalidByPeriodPermit()$$

-- Удаление процедур.
DROP PROCEDURE IF EXISTS updateTempInvalid$$
DROP PROCEDURE IF EXISTS updateTempInvalidClientId$$
DROP PROCEDURE IF EXISTS updateTempInvalidByPeriod$$
DROP PROCEDURE IF EXISTS updateTempInvalidByPeriodPermit$$

DELIMITER ;


INSERT INTO `DatabaseVersion` (`base_version`, `updated`) VALUES ('ucor201803-01', NOW());