/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES 'utf8' COLLATE 'utf8_general_ci' */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


-- 2018-04-16 14:38:05
-- 0009692: ТФОМС СПб. Изменения по Приказу №79 (апрель)
-- добавляем систему идентификации
INSERT INTO rbAccountingSystem (`code`, `name`, `urn`, `version`, `domain`, `createDatetime`, `modifyDatetime`)
SELECT  'tfoms78.BED_PROFILE',
        'Профили коек ТФОМС СПб в ЕИС ОМС',
        'urn:tfoms78:SPRAV_BED_PROFILE',
        '1',
        'rbHospitalBedProfile',
        NOW(),
        NOW()
FROM DUAL
WHERE NOT EXISTS(SELECT id
                 FROM rbAccountingSystem
                 WHERE urn='urn:tfoms78:SPRAV_BED_PROFILE'
                );

-- добавляем идентификаторы профилей коек
INSERT INTO rbHospitalBedProfile_Identification (master_id, system_id,  value, createDatetime, modifyDatetime)
SELECT  rbHospitalBedProfile.id,
        rbAccountingSystem.id,
        T.code,
       NOW(),
       NOW()
FROM rbHospitalBedProfile
INNER JOIN (       SELECT  '4' AS code, 'для беременных и рожениц' AS name
UNION SELECT  '5' AS code, 'патологии беременности' AS name
UNION SELECT  '6' AS code, 'гинекологические' AS name
UNION SELECT  '7' AS code, 'гинекологические для детей' AS name
UNION SELECT  '8' AS code, 'гинекологические для вспомогательных репродуктивных технологий' AS name
UNION SELECT  '9' AS code, 'аллергологические' AS name
UNION SELECT  '10' AS code, 'реанимационные' AS name
UNION SELECT  '11' AS code, 'реанимационные для новорожденных' AS name
UNION SELECT  '12' AS code, 'интенсивной терапии' AS name
UNION SELECT  '13' AS code, 'интенсивной терапии для новорожденных' AS name
UNION SELECT  '14' AS code, 'гастроэнтерологические' AS name
UNION SELECT  '15' AS code, 'гематологические' AS name
UNION SELECT  '16' AS code, 'геронтологические' AS name
UNION SELECT  '17' AS code, 'дерматологические' AS name
UNION SELECT  '18' AS code, 'венерологические' AS name
UNION SELECT  '19' AS code, 'кардиологические для детей' AS name
UNION SELECT  '20' AS code, 'онкологические для детей' AS name
UNION SELECT  '21' AS code, 'уроандрологические для детей' AS name
UNION SELECT  '22' AS code, 'хирургические для детей' AS name
UNION SELECT  '23' AS code, 'эндокринологические для детей' AS name
UNION SELECT  '24' AS code, 'инфекционные, лепрозные' AS name
UNION SELECT  '25' AS code, 'кардиологические' AS name
UNION SELECT  '26' AS code, 'кардиологические интенсивной терапии' AS name
UNION SELECT  '27' AS code, 'кардиологические для больных с острым инфарктом миокарда' AS name
UNION SELECT  '28' AS code, 'проктологические' AS name
UNION SELECT  '29' AS code, 'реабилитационные соматические' AS name
UNION SELECT  '30' AS code, 'реабилитац. для больных с заболеваниями центральной нервной системы и ор-в чувств' AS name
UNION SELECT  '31' AS code, 'реабилитац. для больных с заболеваниями опорно-двигательного аппарата и периферич-й нервной системы' AS name
UNION SELECT  '32' AS code, 'неврологические' AS name
UNION SELECT  '33' AS code, 'неврологические интенсивной терапии' AS name
UNION SELECT  '34' AS code, 'нейрохирургические' AS name
UNION SELECT  '35' AS code, 'нефрологические' AS name
UNION SELECT  '36' AS code, 'онкологические' AS name
UNION SELECT  '37' AS code, 'онкологические торакальные' AS name
UNION SELECT  '38' AS code, 'онкологические абдоминальные' AS name
UNION SELECT  '39' AS code, 'онкоурологические' AS name
UNION SELECT  '40' AS code, 'онкогинекологические' AS name
UNION SELECT  '41' AS code, 'онкологические опухолей головы и шеи' AS name
UNION SELECT  '42' AS code, 'онкологические опухолей костей' AS name
UNION SELECT  '43' AS code, 'кожи и мягких тканей' AS name
UNION SELECT  '44' AS code, 'онкологические паллиативные' AS name
UNION SELECT  '45' AS code, 'оториноларингологические, оториноларингологические для кохлеарной имплантации' AS name
UNION SELECT  '46' AS code, 'офтальмологические' AS name
UNION SELECT  '48' AS code, 'педиатрические соматические' AS name
UNION SELECT  '49' AS code, 'хирургические' AS name
UNION SELECT  '56' AS code, 'пульмонологические' AS name
UNION SELECT  '57' AS code, 'радиологические' AS name
UNION SELECT  '58' AS code, 'ревматологические' AS name
UNION SELECT  '59' AS code, 'кардиохирургические, сосудистой хирургии' AS name
UNION SELECT  '60' AS code, 'скорой медицинской помощи краткосрочного пребывания' AS name
UNION SELECT  '61' AS code, 'скорой медицинской помощи суточного пребывания' AS name
UNION SELECT  '62' AS code, 'стоматологические для детей' AS name
UNION SELECT  '63' AS code, 'терапевтические' AS name
UNION SELECT  '64' AS code, 'токсикологические' AS name
UNION SELECT  '65' AS code, 'торакальной хирургии' AS name
UNION SELECT  '66' AS code, 'травматологические' AS name
UNION SELECT  '67' AS code, 'ортопедические' AS name
UNION SELECT  '69' AS code, 'урологические' AS name
UNION SELECT  '71' AS code, 'гнойные хирургические' AS name
UNION SELECT  '72' AS code, 'хирургические' AS name
UNION SELECT  '73' AS code, 'абдоминальной хирургии' AS name
UNION SELECT  '76' AS code, 'челюстно-лицевой хирургии' AS name
UNION SELECT  '77' AS code, 'эндокринологические' AS name ) AS T on T.name = rbHospitalBedProfile.name,
rbAccountingSystem
WHERE rbAccountingSystem.urn = 'urn:tfoms78:SPRAV_BED_PROFILE';

INSERT INTO `DatabaseVersion` (`base_version`, `updated`) VALUES ('ucor201804-01', NOW());

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
