/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES 'utf8' COLLATE 'utf8_general_ci' */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


-- 2018-02-20 16:33:11
-- Изменение в структуре КЛАДР для #0009569: П91. Не войти в картотеку. Медленное выполнение запроса.
USE kladr;
ALTER TABLE STREET
ENGINE=InnoDB,
ADD level4    CHAR(15) NOT NULL DEFAULT '' COMMENT 'Четвёртый уровень = СС РРР ГГГ ППП = LEFT(CODE, 11)',
ADD level5    CHAR(15) NOT NULL DEFAULT '' COMMENT 'Пятый уровень = СС РРР ГГГ ППП УУУУ = LEFT(CODE, 15)',
ADD actuality CHAR(2)  NOT NULL DEFAULT '' COMMENT 'Признак актуальности = RIGHT(CODE, 2)',
ADD KEY level4 ( actuality, level4, OCATD ),
ADD KEY level5 ( actuality, level5, OCATD );

ALTER TABLE DOMA
ENGINE=InnoDB,
ADD level5    CHAR(15) NOT NULL DEFAULT '' COMMENT 'Пятый уровень = СС РРР ГГГ ППП УУУУ = LEFT(CODE, 15)',
ADD KEY level5 ( level5, OCATD );

DELIMITER //
CREATE TRIGGER STREET_onCreate BEFORE INSERT ON STREET
FOR EACH ROW
BEGIN
    SET NEW.level4    = LEFT(NEW.CODE, 11);
    SET NEW.level5    = LEFT(NEW.CODE, 15);
    SET NEW.actuality = RIGHT(NEW.CODE, 2);
END
//
CREATE TRIGGER STREET_onUpdate BEFORE UPDATE ON STREET
FOR EACH ROW
BEGIN
    SET NEW.level4    = LEFT(NEW.CODE, 11);
    SET NEW.level5    = LEFT(NEW.CODE, 15);
    SET NEW.actuality = RIGHT(NEW.CODE, 2);
END
//
CREATE TRIGGER DOMA_onCreate BEFORE INSERT ON DOMA
FOR EACH ROW
BEGIN
    SET NEW.level5    = LEFT(NEW.CODE, 15);
END
//
CREATE TRIGGER DOMA_onUpdate BEFORE UPDATE ON DOMA
FOR EACH ROW
BEGIN
    SET NEW.level5    = LEFT(NEW.CODE, 15);
END
//
DELIMITER ;

update STREET set level5='x';
update DOMA set level5='x';
  
INSERT INTO `s11`.`DatabaseVersion` (`base_version`, `updated`) VALUES ('uk201802-01', NOW());


/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
