/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES 'utf8' COLLATE 'utf8_general_ci' */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


-- 2017-09-12 16:44:07
-- Небольшие правки. Задача №0009171.
DELIMITER //

DROP FUNCTION IF EXISTS `checkClientContingentTypeEventType`//
CREATE DEFINER=`root`@`localhost` FUNCTION `checkClientContingentTypeEventType`(
    aClientId INT,
    aContingentTypeId INT) RETURNS TINYINT(1)
    READS SQL DATA
    DETERMINISTIC
    COMMENT 'Return 0,1,2,3 by corresponds to rbContingentType_EventType'

BEGIN

    DECLARE vResult TINYINT;
    DECLARE vResultEventId INT;
    DECLARE vResultEventEndDate DATE;
    DECLARE vControlPeriod TINYINT(1);
    DECLARE vControlBegDate DATE;
    DECLARE vControlEndDate DATE;
    DECLARE vEventTypeId INT;
    DECLARE vFreePeriod INT;
    DECLARE vContingentTypeEventTypeCursor CURSOR FOR SELECT `eventType_id`, `controlPeriod`, `freePeriod` FROM rbContingentType_EventType
    WHERE `master_id` = aContingentTypeId;
    DECLARE CONTINUE HANDLER FOR NOT FOUND SET vResult = NULL;

    SET vResult = 0;

    OPEN vContingentTypeEventTypeCursor;

    contingentTypeEventTypeLoop : LOOP
    FETCH vContingentTypeEventTypeCursor INTO vEventTypeId, vControlPeriod, vFreePeriod;

    IF ISNULL(vResult) THEN
      SET vResult = 0;
      LEAVE contingentTypeEventTypeLoop;
        END IF;

    CASE vControlPeriod
        WHEN 0 THEN SET vControlEndDate = DATE_ADD(DATE_ADD(CURDATE(), INTERVAL 1 YEAR), INTERVAL -DAYOFYEAR(DATE_ADD(CURDATE(), INTERVAL 1 YEAR)) DAY);
        SET vControlBegDate = DATE_ADD(vControlEndDate, INTERVAL -(DAYOFYEAR(vControlEndDate)-1) DAY);
        WHEN 1 THEN SET vControlBegDate = DATE_ADD(CURDATE(), INTERVAL -(vFreePeriod-1) DAY); SET vControlEndDate = CURDATE();
        WHEN 2 THEN SET vControlBegDate = DATE_ADD(DATE_ADD(CURDATE(), INTERVAL 1 DAY), INTERVAL -(vFreePeriod) WEEK); SET vControlEndDate = CURDATE();
        WHEN 3 THEN SET vControlBegDate = DATE_ADD(DATE_ADD(CURDATE(), INTERVAL 1 DAY), INTERVAL -(vFreePeriod) MONTH); SET vControlEndDate = CURDATE();
        WHEN 4 THEN SET vControlBegDate = DATE_ADD(DATE_ADD(CURDATE(), INTERVAL 1 DAY), INTERVAL -(vFreePeriod) YEAR); SET vControlEndDate = CURDATE();
        ELSE ITERATE contingentTypeEventTypeLoop;
    END CASE;

    IF ISNULL(vControlBegDate) THEN
      SELECT `id`, `execDate` FROM `Event` WHERE `client_id`=aClientId AND deleted = 0 AND `eventType_id`=vEventTypeId AND DATE(`setDate`) <= vControlEndDate
      ORDER BY setDate DESC
      LIMIT 1 INTO vResultEventId, vResultEventEndDate;
    ELSE
      SELECT `id`, `execDate` FROM `Event`
      WHERE `client_id`=aClientId AND deleted = 0 AND `eventType_id`=vEventTypeId AND DATE(`setDate`) >= vControlBegDate AND DATE(`setDate`) <= vControlEndDate
      ORDER BY setDate DESC
      LIMIT 1 INTO vResultEventId, vResultEventEndDate;
    END IF;

    IF vResultEventId THEN
        IF ISNULL(vResultEventEndDate) THEN
        SET vResult = 1;
        ELSE
        SET vResult = 2;
        END IF;
    ELSE
      set vResult = 0;
    END IF;

    IF vResult > 0 THEN
        LEAVE contingentTypeEventTypeLoop;
        END IF;

    END LOOP contingentTypeEventTypeLoop;
    CLOSE vContingentTypeEventTypeCursor;
    RETURN vResult;
END//


--
DROP FUNCTION IF EXISTS `checkClientContingentTypeActionType`//
CREATE DEFINER=`root`@`localhost` FUNCTION `checkClientContingentTypeActionType`(
    aClientId INT,
    aContingentTypeId INT) RETURNS TINYINT(1)
    READS SQL DATA
    DETERMINISTIC
    COMMENT 'Return 0,1,2,3 by corresponds to rbContingentType_ActionType'
BEGIN

    DECLARE vResult TINYINT;
    DECLARE vResultActionId INT;
    DECLARE vResultActionEndDate DATE;

    DECLARE vControlPeriod TINYINT(1);
    DECLARE vControlBegDate DATE;
    DECLARE vControlEndDate DATE;
    DECLARE vActionTypeId INT;
    DECLARE vFreePeriod INT;

    DECLARE vContingentTypeActionTypeCursor CURSOR FOR SELECT `actionType_id`, `controlPeriod`, `freePeriod` FROM rbContingentType_ActionType
    WHERE `master_id` = aContingentTypeId;
    DECLARE CONTINUE HANDLER FOR NOT FOUND SET vResult = NULL;

    SET vResult = 0;

    OPEN vContingentTypeActionTypeCursor;

    contingentTypeActionTypeLoop : LOOP
    FETCH vContingentTypeActionTypeCursor INTO vActionTypeId, vControlPeriod, vFreePeriod;

    IF ISNULL(vResult) THEN
      SET vResult = 0;
      LEAVE contingentTypeActionTypeLoop;
        END IF;

    CASE vControlPeriod
        WHEN 0 THEN SET vControlEndDate = DATE_ADD(DATE_ADD(CURDATE(), INTERVAL 1 YEAR), INTERVAL -DAYOFYEAR(DATE_ADD(CURDATE(), INTERVAL 1 YEAR)) DAY);
        SET vControlBegDate = DATE_ADD(vControlEndDate, INTERVAL -(DAYOFYEAR(vControlEndDate)-1) DAY);
        WHEN 1 THEN SET vControlBegDate = DATE_ADD(CURDATE(), INTERVAL -(vFreePeriod-1) DAY); SET vControlEndDate = CURDATE();
        WHEN 2 THEN SET vControlBegDate = DATE_ADD(DATE_ADD(CURDATE(), INTERVAL 1 DAY), INTERVAL -(vFreePeriod) WEEK); SET vControlEndDate = CURDATE();
        WHEN 3 THEN SET vControlBegDate = DATE_ADD(DATE_ADD(CURDATE(), INTERVAL 1 DAY), INTERVAL -(vFreePeriod) MONTH); SET vControlEndDate = CURDATE();
        WHEN 4 THEN SET vControlBegDate = DATE_ADD(DATE_ADD(CURDATE(), INTERVAL 1 DAY), INTERVAL -(vFreePeriod) YEAR); SET vControlEndDate = CURDATE();
        ELSE ITERATE contingentTypeActionTypeLoop;
    END CASE;

    IF ISNULL(vControlBegDate) THEN
      SELECT Action.`id`, Action.`endDate`
      FROM `Action` INNER JOIN Event ON (Action.event_id = Event.id  AND Event.`client_id`= aClientId AND Event.deleted = 0)
      WHERE Action.`actionType_id`=vActionTypeId AND Action.deleted = 0 AND DATE(Action.`begDate`) <= vControlEndDate
      ORDER BY Action.begDate DESC
      LIMIT 1 INTO vResultActionId, vResultActionEndDate;
    ELSE
      SELECT Action.`id`, Action.`endDate`
      FROM Action INNER JOIN `Event` ON (Action.event_id = Event.id AND Event.`client_id`= aClientId AND Event.deleted = 0)
      WHERE Action.`actionType_id`=vActionTypeId AND Action.deleted = 0 AND DATE(Action.`begDate`) >= vControlBegDate AND DATE(Action.`begDate`) <= vControlEndDate
      ORDER BY Action.begDate DESC
      LIMIT 1 INTO vResultActionId, vResultActionEndDate;
    END IF;

    IF vResultActionId THEN
        IF ISNULL(vResultActionEndDate) THEN
        SET vResult = 1;
        ELSE
        SET vResult = 2;
        END IF;
    ELSE
      set vResult = 0;
    END IF;

    IF vResult > 0 THEN
        LEAVE contingentTypeActionTypeLoop;
        END IF;


    END LOOP contingentTypeActionTypeLoop;

    CLOSE vContingentTypeActionTypeCursor;

    RETURN vResult;
END//


--
DROP FUNCTION IF EXISTS `checkClientContingentTypeMES`//
CREATE DEFINER=`root`@`localhost` FUNCTION `checkClientContingentTypeMES`(
    aClientId INT,
    aContingentTypeId INT) RETURNS TINYINT(1)
    READS SQL DATA
    DETERMINISTIC
    COMMENT 'Return 0,1,2,3 by corresponds to rbContingentType_MES'
BEGIN

    DECLARE vResult TINYINT(1);
    DECLARE vResultEventId INT;
    DECLARE vResultEventEndDate DATE;

    DECLARE vControlPeriod TINYINT(1);
    DECLARE vControlBegDate DATE;
    DECLARE vControlEndDate DATE;
    DECLARE vMESId INT;
    DECLARE vFreePeriod INT;

    DECLARE vContingentTypeMESCursor CURSOR FOR SELECT `MES_id`, `controlPeriod`, `freePeriod` FROM rbContingentType_MES WHERE `master_id` = aContingentTypeId;
    DECLARE CONTINUE HANDLER FOR NOT FOUND SET vResult = NULL;

    SET vResult = 0;

    OPEN vContingentTypeMESCursor;

    contingentTypeMESLoop : LOOP

    FETCH vContingentTypeMESCursor INTO vMESId, vControlPeriod, vFreePeriod;

    IF ISNULL(vResult) THEN
        SET vResult = 0;
        LEAVE contingentTypeMESLoop;
    END IF;

      CASE vControlPeriod
        WHEN 0 THEN SET vControlEndDate = DATE_ADD(DATE_ADD(CURDATE(), INTERVAL 1 YEAR), INTERVAL -DAYOFYEAR(DATE_ADD(CURDATE(), INTERVAL 1 YEAR)) DAY);
        SET vControlBegDate = DATE_ADD(vControlEndDate, INTERVAL -(DAYOFYEAR(vControlEndDate)-1) DAY);
        WHEN 1 THEN SET vControlBegDate = DATE_ADD(CURDATE(), INTERVAL -(vFreePeriod-1) DAY); SET vControlEndDate = CURDATE();
        WHEN 2 THEN SET vControlBegDate = DATE_ADD(DATE_ADD(CURDATE(), INTERVAL 1 DAY), INTERVAL -(vFreePeriod) WEEK); SET vControlEndDate = CURDATE();
        WHEN 3 THEN SET vControlBegDate = DATE_ADD(DATE_ADD(CURDATE(), INTERVAL 1 DAY), INTERVAL -(vFreePeriod) MONTH); SET vControlEndDate = CURDATE();
        WHEN 4 THEN SET vControlBegDate = DATE_ADD(DATE_ADD(CURDATE(), INTERVAL 1 DAY), INTERVAL -(vFreePeriod) YEAR); SET vControlEndDate = CURDATE();
        ELSE ITERATE contingentTypeMESLoop;
      END CASE;

      IF ISNULL(vControlBegDate) THEN
        SELECT `id`, `execDate`
        FROM `Event`
        WHERE `client_id`=aClientId AND deleted = 0 AND `MES_id`=vMESId AND DATE(`setDate`) <= vControlEndDate
        ORDER BY setDate DESC
        LIMIT 1 INTO vResultEventId, vResultEventEndDate;
      ELSE
        SELECT `id`, `execDate`
        FROM `Event`
        WHERE `client_id`=aClientId AND deleted = 0 AND `MES_id`=vMESId AND DATE(`setDate`) >= vControlBegDate AND DATE(`setDate`) <= vControlEndDate
        ORDER BY setDate DESC
        LIMIT 1 INTO vResultEventId, vResultEventEndDate;
      END IF;

      IF vResultEventId THEN
        IF ISNULL(vResultEventEndDate) THEN
            SET vResult = 1;
        ELSE
            SET vResult = 2;
        END IF;
      ELSE
        set vResult = 0;
      END IF;

      IF vResult > 0 THEN
        LEAVE contingentTypeMESLoop;
    END IF;

    END LOOP contingentTypeMESLoop;

    CLOSE vContingentTypeMESCursor;
    RETURN vResult;
END//


--
DROP FUNCTION IF EXISTS `checkClientContingentTypeSocStatus`//
CREATE DEFINER=`root`@`localhost` FUNCTION `checkClientContingentTypeSocStatus`(
    aClientId INT,
    aContingentTypeId INT) RETURNS INT
    READS SQL DATA
    DETERMINISTIC
    COMMENT 'Return actual ClientSocStatus.`id` to contingent type'
BEGIN

    DECLARE vResult INT;
    DECLARE vControlPeriod TINYINT(1);
    DECLARE vControlDate DATE;
    DECLARE vSocStatusTypeId INT;
    DECLARE vEndFetching TINYINT(1);
    DECLARE vSocStatusTypeCnt INT;
    DECLARE vContingentTypeSocStatusCursor CURSOR FOR SELECT `socStatusType_id`, `controlPeriod` FROM rbContingentType_SocStatus WHERE `master_id` = aContingentTypeId;
    DECLARE CONTINUE HANDLER FOR NOT FOUND SET vEndFetching = 1;

    SET vSocStatusTypeCnt = 0;
    SELECT COUNT(`id`) FROM rbContingentType_SocStatus  WHERE `master_id` = aContingentTypeId INTO vSocStatusTypeCnt;
    SET vResult = 0;
    SET vEndFetching = 0;
    OPEN vContingentTypeSocStatusCursor;
    contingentTypeSocStatusLoop : LOOP
        FETCH vContingentTypeSocStatusCursor INTO vSocStatusTypeId, vControlPeriod;
        IF vEndFetching > vSocStatusTypeCnt THEN
           LEAVE contingentTypeSocStatusLoop;
        END IF;
        CASE vControlPeriod
            WHEN 0 THEN SET vControlDate = CURDATE();
            WHEN 1 THEN SET vControlDate = DATE_ADD(CURDATE(), INTERVAL -DAYOFYEAR(CURDATE()) DAY);
            WHEN 2 THEN SET vControlDate = DATE_ADD(DATE_ADD(CURDATE(), INTERVAL 1 YEAR), INTERVAL -DAYOFYEAR(DATE_ADD(CURDATE(), INTERVAL 1 YEAR)) DAY);
            ELSE ITERATE contingentTypeSocStatusLoop;
        END CASE;
        SELECT `id`
        FROM ClientSocStatus
        WHERE `client_id`=aClientId AND deleted = 0 AND socStatusType_id=vSocStatusTypeId AND (DATE(`begDate`) <= vControlDate OR `begDate` IS NULL)
        AND (DATE(`endDate`) >= vControlDate OR `endDate` IS NULL)
        LIMIT 1 INTO vResult;
        IF vResult THEN
           LEAVE contingentTypeSocStatusLoop;
        END IF;
        SET vSocStatusTypeCnt = vSocStatusTypeCnt - 1;
        if vSocStatusTypeCnt <= 0 THEN
           LEAVE contingentTypeSocStatusLoop;
        END IF;
    END LOOP contingentTypeSocStatusLoop;
    CLOSE vContingentTypeSocStatusCursor;

    RETURN vResult;
END//

DELIMITER ;


INSERT INTO `DatabaseVersion` (`base_version`, `updated`) VALUES ('up201709-06', NOW());

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
