/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES 'utf8' COLLATE 'utf8_general_ci' */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


-- 2017-11-22 16:32:46
-- Создаём новую таблицу TempInvalidDocument. Задача №0009358: "ВУТ. Учет документов".
CREATE TABLE `TempInvalidDocument` (
    `id` INT(11) NOT NULL AUTO_INCREMENT,
    `createDatetime` DATETIME NOT NULL COMMENT 'Дата создания записи',
    `createPerson_id` INT(11) NULL DEFAULT NULL COMMENT 'Автор записи {Person}',
    `modifyDatetime` DATETIME NOT NULL COMMENT 'Дата изменения записи',
    `modifyPerson_id` INT(11) NULL DEFAULT NULL COMMENT 'Автор изменения записи {Person}',
    `deleted` TINYINT(1) NOT NULL DEFAULT '0' COMMENT 'Отметка удаления записи',
    `master_id` INT(11) NOT NULL COMMENT 'Master запись {TempInvalid}',
    `issueDate` DATE NULL DEFAULT NULL COMMENT 'Дата выдачи листа нетрудоспособности',
    `serial` VARCHAR(8) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'Серия документа',
    `number` VARCHAR(16) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'Номер документа',
    `duplicate` TINYINT(1) NOT NULL DEFAULT '0' COMMENT 'Флаг "дубликат" (Нет/Да)',
    `electronic` TINYINT(1) NOT NULL DEFAULT '0' COMMENT 'Флаг "электронный" (Нет/Да)',
    `busyness` TINYINT(4) NOT NULL DEFAULT '0' COMMENT 'Занятость:1- основное,2-совместитель,3-на учете',
    `placeWork` VARCHAR(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'Место работы',
    `prevNumber` VARCHAR(16) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'Продолжение документа с номером',
    `prev_id` INT(11) NULL DEFAULT NULL COMMENT 'Идентификатор продолжения документа {TempInvalidDocument}',
    `person_id` INT(11) NULL DEFAULT NULL COMMENT 'Выдал {Person}',
    `clientPrimum_id` INT(11) NULL DEFAULT NULL COMMENT 'Пациент 1 {Client}',
    `clientSecond_id` INT(11) NULL DEFAULT NULL COMMENT 'Пациент 2 {Client}',
    `last_id` INT(11) NULL DEFAULT NULL COMMENT 'Идентификатор выданного документа (при продлении) {TempInvalidDocument}',
    `note` VARCHAR(256) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'Примечание',
    PRIMARY KEY (`id`),
    KEY `createPerson_id` (`createPerson_id`),
    KEY `modifyPerson_id` (`modifyPerson_id`),
    KEY `master_id` (`master_id`),
    KEY `prev_id` (`prev_id`),
    KEY `person_id` (`person_id`),
    KEY `clientPrimum_id` (`clientPrimum_id`),
    KEY `clientSecond_id` (`clientSecond_id`),
    KEY `last_id` (`last_id`),
    CONSTRAINT `TempInvalidDocument_createPerson` FOREIGN KEY (`createPerson_id`) REFERENCES `Person` (`id`) ON DELETE SET NULL ON UPDATE CASCADE,
    CONSTRAINT `TempInvalidDocument_modifyPerson` FOREIGN KEY (`modifyPerson_id`)  REFERENCES `Person` (`id`) ON DELETE SET NULL ON UPDATE CASCADE,
    CONSTRAINT `TempInvalidDocument_master` FOREIGN KEY (`master_id`) REFERENCES `TempInvalid` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
    CONSTRAINT `TempInvalidDocument_prev` FOREIGN KEY (`prev_id`) REFERENCES `TempInvalidDocument` (`id`) ON DELETE SET NULL ON UPDATE CASCADE,
    CONSTRAINT `TempInvalidDocument_person` FOREIGN KEY (`person_id`)  REFERENCES `Person` (`id`) ON DELETE SET NULL ON UPDATE CASCADE,
    CONSTRAINT `TempInvalidDocument_clientPrimum` FOREIGN KEY (`clientPrimum_id`) REFERENCES `Client` (`id`) ON DELETE SET NULL ON UPDATE CASCADE,
    CONSTRAINT `TempInvalidDocument_clientSecond` FOREIGN KEY (`clientSecond_id`) REFERENCES `Client` (`id`) ON DELETE SET NULL ON UPDATE CASCADE,
    CONSTRAINT `TempInvalidDocument_last` FOREIGN KEY (`last_id`) REFERENCES `TempInvalidDocument` (`id`) ON DELETE SET NULL ON UPDATE CASCADE
    ) ENGINE = InnoDB DEFAULT CHARSET=utf8 COMMENT = 'Документы ВУТ';

-- В таблицу TempInvalid добавляем поля. Задача №0009358: "ВУТ. Учет документов".
ALTER TABLE `TempInvalid`
  ADD COLUMN `begDateStationary` DATE NULL DEFAULT NULL COMMENT 'В стационаре "с"',
  ADD COLUMN `endDateStationary` DATE NULL DEFAULT NULL COMMENT 'В стационаре "по"',
  ADD COLUMN `break_id` INT(11) NULL DEFAULT NULL COMMENT 'Нарушение режима {rbTempInvalidBreak}',
  ADD COLUMN `breakDate` DATE NULL DEFAULT NULL COMMENT 'Дата нарушения режима',
  ADD COLUMN `result_id` INT(11) NULL DEFAULT NULL COMMENT 'Результат {rbTempInvalidResult}',
  ADD COLUMN `resultDate` DATE NULL DEFAULT NULL COMMENT 'Дата результата',
  ADD COLUMN `numberPermit` VARCHAR(16) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'Номер путевки',
  ADD COLUMN `begDatePermit` DATE NULL DEFAULT NULL COMMENT 'Дата начала путевки',
  ADD COLUMN `endDatePermit` DATE NULL DEFAULT NULL COMMENT 'Дата окончания путевки',
  ADD COLUMN `disability_id` INT(11) NULL DEFAULT NULL COMMENT 'Инвалидность {rbTempInvalidRegime}',
  ADD KEY `break_id` (`break_id`),
  ADD KEY `result_id` (`result_id`),
  ADD KEY `disability_id` (`disability_id`),
  ADD CONSTRAINT `TempInvalid_break` FOREIGN KEY (`break_id`) REFERENCES `rbTempInvalidBreak` (`id`) ON DELETE SET NULL ON UPDATE CASCADE,
  ADD CONSTRAINT `TempInvalid_result` FOREIGN KEY (`result_id`) REFERENCES `rbTempInvalidResult` (`id`) ON DELETE SET NULL ON UPDATE CASCADE,
  ADD CONSTRAINT `TempInvalid_disability` FOREIGN KEY (`disability_id`) REFERENCES `rbTempInvalidRegime` (`id`) ON DELETE SET NULL ON UPDATE CASCADE;


  
  
INSERT INTO `DatabaseVersion` (`base_version`, `updated`) VALUES ('up201711-08', NOW());

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
