/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES 'utf8' COLLATE 'utf8_general_ci' */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


-- 2018-03-22 18:26:46
-- Справочники. Задача №0009578: Учет работы врачебной комиссии (ВК).
CREATE TABLE `rbMedicalBoardExpertiseCharacter` (
  `id`        int(11)      NOT NULL auto_increment,
  `code`   varchar(64)  NOT NULL COMMENT 'Код',
  `name`  varchar(128) NOT NULL COMMENT 'Наименование',
  `class`  TINYINT(4) NOT NULL COMMENT 'Класс экспертизы',
  PRIMARY KEY  (`id`),
  KEY `code` (`code`),
  KEY `name` (`name`),
  KEY `class` (`class`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8  COMMENT 'Характеристики экспертизы';

CREATE TABLE `rbMedicalBoardExpertiseKind` (
  `id`        int(11)      NOT NULL auto_increment,
  `code`   varchar(64)  NOT NULL COMMENT 'Код',
  `name`  varchar(128) NOT NULL COMMENT 'Наименование',
  `expertiseCharacter_id` int(11) NOT NULL COMMENT 'Характеристика экспертизы {rbMedicalBoardExpertiseCharacter}',
  PRIMARY KEY  (`id`),
  KEY `code` (`code`),
  KEY `name` (`name`),
  KEY `expertiseCharacter_id` (`expertiseCharacter_id`),
  CONSTRAINT `rbMedicalBoardExpertiseKind_expertiseCharacter` FOREIGN KEY (`expertiseCharacter_id`) REFERENCES `rbMedicalBoardExpertiseCharacter` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT 'Виды экспертизы';

CREATE TABLE `rbMedicalBoardExpertiseObject` (
  `id`        int(11)      NOT NULL auto_increment,
  `code`   varchar(64)  NOT NULL COMMENT 'Код',
  `name`  varchar(128) NOT NULL COMMENT 'Наименование',
  `expertiseCharacter_id` int(11) NOT NULL COMMENT 'Характеристика экспертизы {rbMedicalBoardExpertiseCharacter}',
  PRIMARY KEY  (`id`),
  KEY `code` (`code`),
  KEY `name` (`name`),
  KEY `expertiseCharacter_id` (`expertiseCharacter_id`),
  CONSTRAINT `rbMedicalBoardExpertiseObject_expertiseCharacter` FOREIGN KEY (`expertiseCharacter_id`) REFERENCES `rbMedicalBoardExpertiseCharacter` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
)ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT 'Предметы экспертизы';

CREATE TABLE `rbMedicalBoardExpertiseArgument` (
  `id`        int(11)      NOT NULL auto_increment,
  `code`   varchar(64)  NOT NULL COMMENT 'Код',
  `name`  varchar(128) NOT NULL COMMENT 'Наименование',
  `expertiseCharacter_id` int(11) NOT NULL COMMENT 'Характеристика экспертизы {rbMedicalBoardExpertiseCharacter}',
  PRIMARY KEY  (`id`),
  KEY `code` (`code`),
  KEY `name` (`name`),
  KEY `expertiseCharacter_id` (`expertiseCharacter_id`),
  CONSTRAINT `rbMedicalBoardExpertiseArgument_expertiseCharacter` FOREIGN KEY (`expertiseCharacter_id`) REFERENCES `rbMedicalBoardExpertiseCharacter` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
)ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT 'Обоснования экспертизы';


INSERT INTO `DatabaseVersion` (`base_version`, `updated`) VALUES ('up201803-13', NOW());

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
