/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES 'utf8' COLLATE 'utf8_general_ci' */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


-- 2018-03-23 12:29:32
-- Таблицы для хранения значения свойств Экспертизы Врачебной комиссии (для СReferenceActionPropertyValueType). Задача №0009578: Учет работы врачебной комиссии (ВК).
-- Характеристика экспертизы
CREATE TABLE `ActionProperty_rbMedicalBoardExpertiseCharacter` (
  `id`       int(11) NOT NULL COMMENT '{ActionProperty}',
  `index`  int(11) NOT NULL DEFAULT '0' COMMENT 'Индекс элемента векторного значения или 0',
  `value` int(11) DEFAULT NULL COMMENT 'собственно значение {rbMedicalBoardExpertiseCharacter}',
  PRIMARY KEY (`id`,`index`),
  KEY `value` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Значение свойства действия типа "Характеристика экспертизы"';

ALTER TABLE `ActionProperty_rbMedicalBoardExpertiseCharacter`
  ADD CONSTRAINT `ActionProperty_rbMedicalBoardExpertiseCharacter_id` FOREIGN KEY (`id`) REFERENCES `ActionProperty` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `ActionProperty_rbMedicalBoardExpertiseCharacter_value` FOREIGN KEY (`value`) REFERENCES `rbMedicalBoardExpertiseCharacter` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

-- Вид экспертизы
CREATE TABLE `ActionProperty_rbMedicalBoardExpertiseKind` (
  `id`       int(11) NOT NULL COMMENT '{ActionProperty}',
  `index`  int(11) NOT NULL DEFAULT '0' COMMENT 'Индекс элемента векторного значения или 0',
  `value` int(11) DEFAULT NULL COMMENT 'собственно значение {rbMedicalBoardExpertiseKind}',
  PRIMARY KEY (`id`,`index`),
  KEY `value` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Значение свойства действия типа "Виды экспертизы"';

ALTER TABLE `ActionProperty_rbMedicalBoardExpertiseKind`
  ADD CONSTRAINT `ActionProperty_rbMedicalBoardExpertiseKind_id` FOREIGN KEY (`id`) REFERENCES `ActionProperty` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `ActionProperty_rbMedicalBoardExpertiseKind_value` FOREIGN KEY (`value`) REFERENCES `rbMedicalBoardExpertiseKind` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

-- Предмет экспертизы
CREATE TABLE `ActionProperty_rbMedicalBoardExpertiseObject` (
  `id`       int(11) NOT NULL COMMENT '{ActionProperty}',
  `index`  int(11) NOT NULL DEFAULT '0' COMMENT 'Индекс элемента векторного значения или 0',
  `value` int(11) DEFAULT NULL COMMENT 'собственно значение {rbMedicalBoardExpertiseObject}',
  PRIMARY KEY (`id`,`index`),
  KEY `value` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Значение свойства действия типа "Предметы экспертизы"';

ALTER TABLE `ActionProperty_rbMedicalBoardExpertiseObject`
  ADD CONSTRAINT `ActionProperty_rbMedicalBoardExpertiseObject_id` FOREIGN KEY (`id`) REFERENCES `ActionProperty` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `ActionProperty_rbMedicalBoardExpertiseObject_value` FOREIGN KEY (`value`) REFERENCES `rbMedicalBoardExpertiseObject` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

-- Обоснование экспертизы
CREATE TABLE `ActionProperty_rbMedicalBoardExpertiseArgument` (
  `id`       int(11) NOT NULL COMMENT '{ActionProperty}',
  `index`  int(11) NOT NULL DEFAULT '0' COMMENT 'Индекс элемента векторного значения или 0',
  `value` int(11) DEFAULT NULL COMMENT 'собственно значение {rbMedicalBoardExpertiseArgument}',
  PRIMARY KEY (`id`,`index`),
  KEY `value` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Значение свойства действия типа "Обоснования экспертизы"';

ALTER TABLE `ActionProperty_rbMedicalBoardExpertiseArgument`
  ADD CONSTRAINT `ActionProperty_rbMedicalBoardExpertiseArgument_id` FOREIGN KEY (`id`) REFERENCES `ActionProperty` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `ActionProperty_rbMedicalBoardExpertiseArgument_value` FOREIGN KEY (`value`) REFERENCES `rbMedicalBoardExpertiseArgument` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;


INSERT INTO `DatabaseVersion` (`base_version`, `updated`) VALUES ('up201803-14', NOW());

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
